0%

『LeetCode』1475 商品折扣后的最终价格

题目

1475. 商品折扣后的最终价格

给你一个数组 prices ,其中 prices[i] 是商店里第 i 件商品的价格。

商店里正在进行促销活动,如果你要买第 i 件商品,那么你可以得到与 prices[j] 相等的折扣,其中 j 是满足 j > iprices[j] <= prices[i]最小下标 ,如果没有满足条件的 j ,你将没有任何折扣。

请你返回一个数组,数组中第 i 个元素是折扣后你购买商品 i 最终需要支付的价格。

示例 1:

输入:prices = [8,4,6,2,3]
输出:[4,2,4,2,3]
解释:
商品 0 的价格为 price[0]=8 ,你将得到 prices[1]=4 的折扣,所以最终价格为 8 - 4 = 4 。
商品 1 的价格为 price[1]=4 ,你将得到 prices[3]=2 的折扣,所以最终价格为 4 - 2 = 2 。
商品 2 的价格为 price[2]=6 ,你将得到 prices[3]=2 的折扣,所以最终价格为 6 - 2 = 4 。
商品 3 和 4 都没有折扣。

示例 2:

输入:prices = [1,2,3,4,5]
输出:[1,2,3,4,5]
解释:在这个例子中,所有商品都没有折扣。

示例 3:

输入:prices = [10,1,1,6]
输出:[9,0,1,6]

提示:

  • 1 <= prices.length <= 500
  • 1 <= prices[i] <= 10^3

标签

栈, 数组, 单调栈


题解

【商品折扣后的最终价格】简单模拟&单调栈

简单模拟

简单题数据范围不大,按照题意模拟即可

1
2
3
4
5
6
7
8
9
10
11
# Code language: Python
class Solution:
def finalPrices(self, prices: List[int]) -> List[int]:
ans = list(prices)
n = len(prices)
for i in range(n - 1, -1, -1):
for j in range(i + 1, n):
if prices[j] <= prices[i]:
ans[i] = prices[i] - prices[j]
break
return ans
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
// Code language: Java
class Solution {
public int[] finalPrices(int[] prices) {
int[] ans = prices.clone();
for (int n = prices.length, i = n - 1; i >= 0; --i) {
for (int j = i + 1; j < n; ++j) {
if (prices[j] <= prices[i]) {
ans[i] = prices[i] - prices[j];
break;
}
}
}
return ans;
}
}
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
// Code language: C++
class Solution {
public:
vector<int> finalPrices(vector<int>& prices) {
vector<int> ans(prices);
for (int n = prices.size(), i = n - 1; i >= 0; --i) {
for (int j = i + 1; j < n; ++j) {
if (prices[j] <= prices[i]) {
ans[i] = prices[i] - prices[j];
break;
}
}
}
return ans;
}
};
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
/* Code language: JavaScript */
/**
* @param {number[]} prices
* @return {number[]}
*/
var finalPrices = function(prices) {
const ans = prices.concat();
for (let n = prices.length, i = n - 1; i >= 0; --i) {
for (let j = i + 1; j < n; ++j) {
if (prices[j] <= prices[i]) {
ans[i] = prices[i] - prices[j];
break;
}
}
}
return ans;
};
  • 时间复杂度: \(O(n^2)\)
  • 空间复杂度: \(O(1)\)

单调栈

要找比某个位置的值小的最大值,不难想到要用单调栈,从后向前遍历

  • 若栈非空且栈顶元素比当前位置的值要大,则将栈顶元素出栈,直到
  • 栈空或栈顶元素比当前位置小,那么此时栈顶元素就是要找的目标值

PS: 注意到 prices 数组中的值均大于 0, 预先向栈中压入一个 0 就不需要判断是否栈空了

1
2
3
4
5
6
7
8
9
10
11
12
# Code language: Python
class Solution:
def finalPrices(self, prices: List[int]) -> List[int]:
ans = prices.copy()
n = len(prices)
st = [0]
for i in range(n - 1, -1, -1):
while prices[i] < st[-1]:
st.pop()
ans[i] = prices[i] - st[-1]
st.append(prices[i])
return ans
1
2
3
4
5
6
7
8
9
10
11
12
13
// Code language: Java
class Solution {
public int[] finalPrices(int[] prices) {
int n = prices.length, p = 0;
int[] ans = prices.clone(), st = new int[n + 1];
for (int i = n - 1; i >= 0; --i) {
while (prices[i] < st[p]) --p;
ans[i] -= st[p];
st[++p] = prices[i];
}
return ans;
}
}
1
2
3
4
5
6
7
8
9
10
11
12
13
// Code language: C++
class Solution {
public:
vector<int> finalPrices(vector<int>& prices) {
vector<int> ans(prices), st(1, 0);
for (int n = prices.size(), i = n - 1; i >= 0; --i) {
while (prices[i] < st.back()) st.pop_back();
ans[i] -= st.back();
st.emplace_back(prices[i]);
}
return ans;
}
};
1
2
3
4
5
6
7
8
9
10
11
12
13
14
/* Code language: JavaScript */
/**
* @param {number[]} prices
* @return {number[]}
*/
var finalPrices = function(prices) {
const ans = prices.concat(), st = new Array(1).fill(0);
for (let n = prices.length, i = n - 1; i >= 0; --i) {
while (prices[i] < st[st.length - 1]) st.pop();
ans[i] -= st[st.length - 1];
st.push(prices[i]);
}
return ans;
};
  • 时间复杂度: \(O(n)\)
  • 空间复杂度: \(O(n)\)

如果对你有帮助的话,请给我点个赞吧~

欢迎前往 我的博客Algorithm - Github 查看更多题解

--- ♥ end ♥ ---

欢迎关注我呀~